import QtQuick 2.2

Item {
    id: textureRenderer

    property Item textureProvider
    property int verticalAlignment: Image.AlignVCenter
    property int horizontalAlignment: Image.AlignHCenter


    ShaderEffect {
        anchors {
            top: verticalAlignment == Image.AlignTop ? parent.top : undefined
            bottom: verticalAlignment == Image.AlignBottom ? parent.bottom : undefined
            verticalCenter: verticalAlignment == Image.AlignVCenter ? parent.verticalCenter : undefined
            left: horizontalAlignment == Image.AlignLeft ? parent.left : undefined
            right: horizontalAlignment == Image.AlignRight ? parent.right : undefined
            horizontalCenter: horizontalAlignment == Image.AlignHCenter ? parent.horizontalCenter : undefined
        }
        property real imageRatio: source.width / source.height
        property real frameRatio: textureRenderer.width / textureRenderer.height
        property bool anchorWidth: imageRatio >= frameRatio
        width: anchorWidth ? textureRenderer.width : textureRenderer.height * imageRatio
        height: anchorWidth ? textureRenderer.width / imageRatio : textureRenderer.height

        property Item source: textureProvider
    }
}
