import QtQuick 2.2
import Ubuntu.Components 1.1

TransformPreview {
    id: transformPreview

    property real minimumValue: -100
    property real maximumValue: 100
    property real defaultValue: 0
    property real value: slider.value

    function formatValue(v) {
        return v.toFixed(0);
    }

    Slider {
        id: slider
        anchors {
            left: parent.left
            leftMargin: units.gu(2)
            right: parent.right
            rightMargin: units.gu(2)
            bottom: parent.bottom
        }
        minimumValue: transformPreview.minimumValue
        maximumValue: transformPreview.maximumValue
        value: transformPreview.defaultValue
        live: true
        function formatValue(v) {
            return transformPreview.formatValue(v);
        }
    }
}
