#include <QtQml>
#include <QtQml/QQmlContext>
#include "backend.h"
#include "image_loader.h"
#include "image_transform.h"
#include "saturation_transform.h"
#include "halide_transform.h"
#include "halide_effect.h"
#include "texture_from_image.h"


void BackendPlugin::registerTypes(const char *uri)
{
    Q_ASSERT(uri == QLatin1String("Filters"));

    qmlRegisterType<ImageLoader>(uri, 1, 0, "ImageLoader");
    qmlRegisterType<ImageTransform>(uri, 1, 0, "ImageTransform");
    qmlRegisterType<SaturationTransform>(uri, 1, 0, "SaturationTransform");
    qmlRegisterType<HalideTransform>(uri, 1, 0, "HalideTransform");
    qmlRegisterType<HalideEffect>(uri, 1, 0, "HalideEffect");
    qmlRegisterType<UPMTextureFromImage>(uri, 1, 0, "TextureFromImage");
}

void BackendPlugin::initializeEngine(QQmlEngine *engine, const char *uri)
{
    QQmlExtensionPlugin::initializeEngine(engine, uri);
}

