#ifndef HALIDE_GENERATORS_COMMON_H
#define HALIDE_GENERATORS_COMMON_H

#include <Halide.h>

namespace {

void set_packed(Halide::OutputImageParam image, int channels = 4) {
    image.set_stride(0, channels);
    image.set_stride(2, 1);
    image.set_extent(2, channels);
}

void schedule_cpu_and_glsl(Halide::ImageParam& input, Halide::Func& function, Halide::Var x, Halide::Var y, Halide::Var c) {
    // FIXME: for some reason get_target() returns a target that does not have OpenGL when jitting
//        Target target = get_target();
    Halide::Target target = Halide::get_jit_target_from_environment();
    if (target.has_feature(Halide::Target::OpenGL)) {
        // Schedule for GLSL
        input.set_bounds(2, 0, 3);
        function.bound(c, 0, 4);
        function.glsl(x, y, c);
    } else {
        // Schedule for CPU
        function.vectorize(c, 4).parallel(y);
    }
}

}

#endif // HALIDE_GENERATORS_COMMON_H


