#ifndef SATURATIONTRANSFORM_H
#define SATURATIONTRANSFORM_H

#include <QObject>
#include "image_transform.h"

class SaturationTransform : public ImageTransform
{
    Q_OBJECT

    Q_PROPERTY(float saturation READ saturation WRITE setSaturation NOTIFY saturationChanged)

public:
    explicit SaturationTransform(QObject *parent = 0);
    ~SaturationTransform();

    float saturation() const;
    void setSaturation(float saturation);

Q_SIGNALS:
    void saturationChanged();

protected:
    virtual QImage transform(QImage input);

private:
    float m_saturation;
};

#endif // SATURATIONTRANSFORM_H

